Index: /palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- /palm/trunk/SOURCE/read_3d_binary.f90	(revision 666)
+++ /palm/trunk/SOURCE/read_3d_binary.f90	(revision 667)
@@ -663,51 +667,51 @@
                 CASE ( 'ts' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   ts(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   ts(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                     tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'ts_av' )
                    IF ( .NOT. ALLOCATED( ts_av ) )  THEN
-                      ALLOCATE( ts_av(nys-1:nyn+1,nxl-1:nxr+1) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   ts_av(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                      ALLOCATE( ts_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   ts_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                        tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'tswst' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   tswst(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   tswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                         tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'tswst_m' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   tswst_m(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   tswst_m(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'u' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   u(:,nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_3d(:,nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   u(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'u_av' )
                    IF ( .NOT. ALLOCATED( u_av ) )  THEN
-                      ALLOCATE( u_av(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   u_av(:,nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_3d(:,nysf-1:nynf+1,nxlf-1:nxrf+1)
+                      ALLOCATE( u_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   u_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'u_m' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   u_m(:,nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_3d(:,nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   u_m(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                 tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'u_m_l' )
                    IF ( k == 1 )  THEN
                       ALLOCATE( tmp_3dwul(nzb:nzt+1, &
-                                          nys_on_file-1:nyn_on_file+1,1:2) )
+                                          nys_on_file-nbgp:nyn_on_file+nbgp,1:2) )
                       READ ( 13 )  tmp_3dwul
                    ENDIF
                    IF ( outflow_l )  THEN
-                      u_m_l(:,nysc-1:nync+1,:) = tmp_3dwul(:,nysf-1:nynf+1,:)
+                      u_m_l(:,nysc-nbgp:nync+nbgp,:) = tmp_3dwul(:,nysf-nbgp:nynf+nbgp,:)
                    ENDIF
 
@@ -715,9 +719,9 @@
                    IF ( k == 1 )  THEN
                       ALLOCATE( tmp_3dwun(nzb:nzt+1,ny-1:ny, &
-                                          nxl_on_file-1:nxr_on_file+1) )
+                                          nxl_on_file-nbgp:nxr_on_file+nbgp) )
                       READ ( 13 )  tmp_3dwun
                    ENDIF
                    IF ( outflow_n )  THEN
-                      u_m_n(:,:,nxlc-1:nxrc+1) = tmp_3dwun(:,:,nxlf-1:nxrf+1)
+                      u_m_n(:,:,nxlc-nbgp:nxrc+nbgp) = tmp_3dwun(:,:,nxlf-nbgp:nxrf+nbgp)
                    ENDIF
 
@@ -725,9 +729,9 @@
                    IF ( k == 1 )  THEN
                       ALLOCATE( tmp_3dwur(nzb:nzt+1,&
-                                          nys_on_file-1:nyn_on_file+1,nx-1:nx) )
+                                          nys_on_file-nbgp:nyn_on_file+nbgp,nx-1:nx) )
                       READ ( 13 )  tmp_3dwur
                    ENDIF
                    IF ( outflow_r )  THEN
-                      u_m_r(:,nysc-1:nync+1,:) = tmp_3dwur(:,nysf-1:nynf+1,:)
+                      u_m_r(:,nysc-nbgp:nync+nbgp,:) = tmp_3dwur(:,nysf-nbgp:nynf+nbgp,:)
                    ENDIF
 
@@ -735,70 +739,70 @@
                    IF ( k == 1 )  THEN
                       ALLOCATE( tmp_3dwus(nzb:nzt+1,0:1, &
-                                          nxl_on_file-1:nxr_on_file+1) )
+                                          nxl_on_file-nbgp:nxr_on_file+nbgp) )
                       READ ( 13 )  tmp_3dwus
                    ENDIF
                    IF ( outflow_s )  THEN
-                      u_m_s(:,:,nxlc-1:nxrc+1) = tmp_3dwus(:,:,nxlf-1:nxrf+1)
+                      u_m_s(:,:,nxlc-nbgp:nxrc+nbgp) = tmp_3dwus(:,:,nxlf-nbgp:nxrf+nbgp)
                    ENDIF
 
                 CASE ( 'us' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   us(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   us(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                     tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'usws' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   usws(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   usws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                       tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'uswst' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   uswst(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   uswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                        tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'usws_m' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   usws_m(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   usws_m(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                         tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'uswst_m' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   uswst_m(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   uswst_m(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'us_av' )
                    IF ( .NOT. ALLOCATED( us_av ) )  THEN
-                      ALLOCATE( us_av(nys-1:nyn+1,nxl-1:nxr+1) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   us_av(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                      ALLOCATE( us_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   us_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                        tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'v' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   v(:,nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_3d(:,nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   v(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                              tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'v_av' )
                    IF ( .NOT. ALLOCATED( v_av ) )  THEN
-                      ALLOCATE( v_av(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   v_av(:,nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_3d(:,nysf-1:nynf+1,nxlf-1:nxrf+1)
+                      ALLOCATE( v_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   v_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'v_m' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   v_m(:,nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_3d(:,nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   v_m(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'v_m_l' )
                    IF ( k == 1 )  THEN
                       ALLOCATE( tmp_3dwvl(nzb:nzt+1,&
-                                          nys_on_file-1:nyn_on_file+1,0:1) )
+                                          nys_on_file-nbgp:nyn_on_file+nbgp,0:1) )
                       READ ( 13 )  tmp_3dwvl
                    ENDIF
                    IF ( outflow_l )  THEN
-                      v_m_l(:,nysc-1:nync+1,:) = tmp_3dwvl(:,nysf-1:nynf+1,:)
+                      v_m_l(:,nysc-nbgp:nync+nbgp,:) = tmp_3dwvl(:,nysf-nbgp:nynf+nbgp,:)
                    ENDIF
 
@@ -806,9 +810,9 @@
                    IF ( k == 1 )  THEN
                       ALLOCATE( tmp_3dwvn(nzb:nzt+1,ny-1:ny, &
-                                          nxl_on_file-1:nxr_on_file+1) )
+                                          nxl_on_file-nbgp:nxr_on_file+nbgp) )
                       READ ( 13 )  tmp_3dwvn
                    ENDIF
                    IF ( outflow_n )  THEN
-                      v_m_n(:,:,nxlc-1:nxrc+1) = tmp_3dwvn(:,:,nxlf-1:nxrf+1)
+                      v_m_n(:,:,nxlc-nbgp:nxrc+nbgp) = tmp_3dwvn(:,:,nxlf-nbgp:nxrf+nbgp)
                    ENDIF
 
@@ -816,9 +820,9 @@
                    IF ( k == 1 )  THEN
                       ALLOCATE( tmp_3dwvr(nzb:nzt+1,&
-                                          nys_on_file-1:nyn_on_file+1,nx-1:nx) )
+                                          nys_on_file-nbgp:nyn_on_file+nbgp,nx-1:nx) )
                       READ ( 13 )  tmp_3dwvr
                    ENDIF
                    IF ( outflow_r )  THEN
-                      v_m_r(:,nysc-1:nync+1,:) = tmp_3dwvr(:,nysf-1:nynf+1,:)
+                      v_m_r(:,nysc-nbgp:nync+nbgp,:) = tmp_3dwvr(:,nysf-nbgp:nynf+nbgp,:)
                    ENDIF
 
@@ -826,75 +830,75 @@
                    IF ( k == 1 )  THEN
                       ALLOCATE( tmp_3dwvs(nzb:nzt+1,1:2, &
-                                          nxl_on_file-1:nxr_on_file+1) )
+                                          nxl_on_file-nbgp:nxr_on_file+nbgp) )
                       READ ( 13 )  tmp_3dwvs
                    ENDIF
                    IF ( outflow_s )  THEN
-                      v_m_s(:,:,nxlc-1:nxrc+1) = tmp_3dwvs(:,:,nxlf-1:nxrf+1)
+                      v_m_s(:,:,nxlc-nbgp:nxrc+nbgp) = tmp_3dwvs(:,:,nxlf-nbgp:nxrf+nbgp)
                    ENDIF
 
                 CASE ( 'vpt' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   vpt(:,nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_3d(:,nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   vpt(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'vpt_av' )
                    IF ( .NOT. ALLOCATED( vpt_av ) )  THEN
-                      ALLOCATE( vpt_av(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   vpt_av(:,nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_3d(:,nysf-1:nynf+1,nxlf-1:nxrf+1)
+                      ALLOCATE( vpt_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   vpt_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'vpt_m' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   vpt_m(:,nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_3d(:,nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   vpt_m(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'vsws' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   vsws(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   vsws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                       tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'vswst' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   vswst(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   vswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                        tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'vsws_m' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   vsws_m(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   vsws_m(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                         tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'vswst_m' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   vswst_m(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   vswst_m(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'w' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   w(:,nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_3d(:,nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   w(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'w_av' )
                    IF ( .NOT. ALLOCATED( w_av ) )  THEN
-                      ALLOCATE( w_av(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   w_av(:,nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_3d(:,nysf-1:nynf+1,nxlf-1:nxrf+1)
+                      ALLOCATE( w_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   w_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'w_m' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   w_m(:,nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_3d(:,nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   w_m(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'w_m_l' )
                    IF ( k == 1 )  THEN
                       ALLOCATE( tmp_3dwwl(nzb:nzt+1,&
-                                          nys_on_file-1:nyn_on_file+1,0:1) )
+                                          nys_on_file-nbgp:nyn_on_file+nbgp,0:1) )
                       READ ( 13 )  tmp_3dwwl
                    ENDIF
                    IF ( outflow_l )  THEN
-                      w_m_l(:,nysc-1:nync+1,:) = tmp_3dwwl(:,nysf-1:nynf+1,:)
+                      w_m_l(:,nysc-nbgp:nync+nbgp,:) = tmp_3dwwl(:,nysf-nbgp:nynf+nbgp,:)
                    ENDIF
 
@@ -902,9 +906,9 @@
                    IF ( k == 1 )  THEN
                       ALLOCATE( tmp_3dwwn(nzb:nzt+1,ny-1:ny, &
-                                          nxl_on_file-1:nxr_on_file+1) )
+                                          nxl_on_file-nbgp:nxr_on_file+nbgp) )
                       READ ( 13 )  tmp_3dwwn
                    ENDIF
                    IF ( outflow_n )  THEN
-                      w_m_n(:,:,nxlc-1:nxrc+1) = tmp_3dwwn(:,:,nxlf-1:nxrf+1)
+                      w_m_n(:,:,nxlc-nbgp:nxrc+nbgp) = tmp_3dwwn(:,:,nxlf-nbgp:nxrf+nbgp)
                    ENDIF
 
@@ -912,9 +916,9 @@
                    IF ( k == 1 )  THEN
                       ALLOCATE( tmp_3dwwr(nzb:nzt+1,&
-                                          nys_on_file-1:nyn_on_file+1,nx-1:nx) )
+                                          nys_on_file-nbgp:nyn_on_file+nbgp,nx-1:nx) )
                       READ ( 13 )  tmp_3dwwr
                    ENDIF
                    IF ( outflow_r )  THEN
-                      w_m_r(:,nysc-1:nync+1,:) = tmp_3dwwr(:,nysf-1:nynf+1,:)
+                      w_m_r(:,nysc-nbgp:nync+nbgp,:) = tmp_3dwwr(:,nysf-nbgp:nynf+nbgp,:)
                    ENDIF
 
@@ -922,9 +926,9 @@
                    IF ( k == 1 )  THEN
                       ALLOCATE( tmp_3dwws(nzb:nzt+1,0:1, &
-                                          nxl_on_file-1:nxr_on_file+1) )
+                                          nxl_on_file-nbgp:nxr_on_file+nbgp) )
                       READ ( 13 )  tmp_3dwws
                    ENDIF
                    IF ( outflow_s )  THEN
-                      w_m_s(:,:,nxlc-1:nxrc+1) = tmp_3dwws(:,:,nxlf-1:nxrf+1)
+                      w_m_s(:,:,nxlc-nbgp:nxrc+nbgp) = tmp_3dwws(:,:,nxlf-nbgp:nxrf+nbgp)
                    ENDIF
                    DEALLOCATE( tmp_3dwws )
@@ -932,14 +936,14 @@
                 CASE ( 'z0' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   z0(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                   z0(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                     tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'z0_av' )
                    IF ( .NOT. ALLOCATED( z0_av ) )  THEN
-                      ALLOCATE( z0_av(nys-1:nyn+1,nxl-1:nxr+1) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   z0_av(nysc-1:nync+1,nxlc-1:nxrc+1) = &
-                                          tmp_2d(nysf-1:nynf+1,nxlf-1:nxrf+1)
+                      ALLOCATE( z0_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   z0_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                       tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE DEFAULT
Index: /palm/trunk/SOURCE/sor.f90
===================================================================
--- /palm/trunk/SOURCE/sor.f90	(revision 666)
+++ /palm/trunk/SOURCE/sor.f90	(revision 667)
@@ -4,5 +4,7 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng.
+! Call of exchange_horiz are modified.
+! bug removed in declaration of ddzw(), nz replaced by nzt+1
 !
 ! Former revisions:
@@ -36,7 +38,7 @@
 
     INTEGER ::  i, j, k, n, nxl1, nxl2, nys1, nys2
-    REAL    ::  ddzu(1:nz+1), ddzw(1:nz)
+    REAL    ::  ddzu(1:nz+1), ddzw(1:nzt+1)
     REAL    ::  d(nzb+1:nzt,nys:nyn,nxl:nxr),         &
-                p(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
+                p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)
     REAL, DIMENSION(:), ALLOCATABLE ::  f1, f2, f3
 
@@ -102,5 +104,5 @@
 !
 !--    Exchange of boundary values for p.
-       CALL exchange_horiz( p )
+       CALL exchange_horiz( p, nbgp )
 
 !
@@ -147,16 +149,12 @@
 !
 !--    Exchange of boundary values for p.
-       CALL exchange_horiz( p )
+       CALL exchange_horiz( p, nbgp )
 
 !
 !--    Boundary conditions top/bottom.
 !--    Bottom boundary
-       IF ( ibc_p_b == 1 )  THEN
-!
-!--       Neumann
+       IF ( ibc_p_b == 1 )  THEN       !       Neumann
           p(nzb,:,:) = p(nzb+1,:,:)
-       ELSE
-!
-!--       Dirichlet
+       ELSE                            !       Dirichlet
           p(nzb,:,:) = 0.0
        ENDIF
@@ -164,11 +162,7 @@
 !
 !--    Top boundary
-       IF ( ibc_p_t == 1 )  THEN
-!
-!--       Neumann
+       IF ( ibc_p_t == 1 )  THEN                 !  Neumann
           p(nzt+1,:,:) = p(nzt,:,:)
-       ELSE
-!
-!--       Dirichlet
+       ELSE                      !  Dirichlet
           p(nzt+1,:,:) = 0.0
        ENDIF
@@ -185,4 +179,5 @@
        ENDIF
 
+
     ENDDO
 
Index: /palm/trunk/SOURCE/subsidence.f90
===================================================================
--- /palm/trunk/SOURCE/subsidence.f90	(revision 666)
+++ /palm/trunk/SOURCE/subsidence.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng.
 !
 ! Former revisions:
@@ -121,5 +121,5 @@
        REAL :: tmp_grad
     
-       REAL, DIMENSION(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) :: var, tendency
+       REAL, DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) :: var, tendency
        REAL, DIMENSION(nzb:nzt+1) :: var_init, var_mod
 
@@ -197,5 +197,5 @@
        REAL :: tmp_grad
     
-       REAL, DIMENSION(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) :: var, tendency
+       REAL, DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) :: var, tendency
        REAL, DIMENSION(nzb:nzt+1) :: var_init, var_mod
 
